<!-- IF [user->staff] -->
<script language="javascript" src="js/treemenu/DynamicTreeBuilder.js"></script>
<!-- ENDIF -->

<div class="rounded_light_blue_box" style="padding: 5px">
<table cellspacing="4">
<tr>
  <td class="label"><label>{language->search_tutorials}:</label></td>
  <td class="field">
    <input type="text" id="search" name="search" onkeydown="if(event.keyCode==13) document.getElementById('search_button').click()" size="40" class="normal" />
    <input type="button" id="search_button" onclick="search_tutorial(document.getElementById('search').value)" class="button" value="{language->search}" />
  </td> 
</tr>
</table>
</div>
<br />

<!-- IF [user->staff] -->
<div style="float: left; width: 240px">
<!-- INCLUDE tutorial_category.tpl -->
</div>
<!-- ENDIF -->

<div <!-- IF [user->staff] -->style="margin-left: 255px"<!-- ENDIF -->>
<div id="content" style="float: left; width: 100%">
<!-- INCLUDE tutorial_content.tpl -->
</div>

<br clear="left" />
</div>
<br clear="left" />

<script language="javascript">

  function display_entry( is_doc, sql_id )
  {
    if( is_doc )
      httpload( "index.php?pid=tutorials&cmd=viewent&id="+sql_id, "content", "{language->loading}" );
    else
      httpload( "index.php?pid=tutorials&cmd=viewcat&id="+sql_id, "content", "{language->loading}" );
  }

  function search_tutorial( search )
  {
    window.location.hash = "search";
    httpload( "index.php?pid=tutorials&cmd=search&search="+escape(search), "content", "{language->loading}" );    
  }

  function filelibrary_loaded( req ) // Load file library menu for editing an entry
  {
    var xml = xml_to_array( req.responseXML );
     
    parse_tree_xml( xml.menu[0].submenu );    
    xml_to_menu( xml, file_menu_action, "filelibrary_menu", "{language->filelibrary}", "", true );
    
    setup_dommenu( "filelibrary_menu" );   
    domMenu_activate( "filelibrary_menu" );      
  }
  
  var related_storage = new Object();
    
  function insert_related( name, id ) // Insert a file into currently edited entry
  {    
    related_storage[id]=name;   
    buildRelatedList();    
  }
  
  function buildRelatedList()
  {
    div=document.getElementById("related_list");
    div.innerHTML="";
    str='';
    for ( keyVar in related_storage ) {      
      div.innerHTML+=related_storage[keyVar]+"&nbsp;<a href='javascript:void(0);' onClick='removeRelated("+keyVar+");'><img src='./images/notedelete.gif' border='0'></a><br>";
      str+=keyVar+'-';
    }
    document.getElementById("related_ids").value = str;    
  }
  
  function removeRelated(id)
  {
    var tmp = new Object();
    for ( keyVar in related_storage ) {
      if(id != keyVar ){
        tmp[keyVar] = related_storage[keyVar];
      }
    }
    related_storage = tmp;
    buildRelatedList();
  }
  
  function delete_related(id, entry_id)
  {
    document.getElementById("related_item_"+id).style.display="none";
    httpload( "index.php?pid=tutorials&cmd=delete_related&relid="+id+"&id="+entry_id, null );          
  }
  
  
  function related_loaded( req ) // Load related items menu 
  {
    var xml = xml_to_array( req.responseXML );
     
    parse_tree_xml( xml.menu[0].submenu );    
    xml_to_menu( xml, related_menu_action, "related_dropdown", "{language->related_tutorials}", "", true );
    
    setup_dommenu( "related_dropdown" );   
    domMenu_activate( "related_dropdown" );  
  } 

  function file_menu_action( id, xml )
  {
    return "javascript:grab_file1(\""+addslashes(xml.name[0].value)+"\","+xml.id[0].value+")";
  }
  
  function related_menu_action( id, xml )
  {
    return "javascript:insert_related(\""+addslashes(xml.name[0].value)+"\","+xml.id[0].value+")";
  }

  var self_id = null;
  
  function edit_entry( is_doc, sql_id )
  {
    if( is_doc ){      
      httpload( "index.php?pid=tutorials&cmd=editent&id="+sql_id, edit_entry_loaded, "{language->loading}" );                  
      self_id = sql_id;
    }else{      
      httpload( "index.php?pid=tutorials&cmd=editcat&id="+sql_id, "content", "{language->loading}" );
    }
    t();
    show_save_success=true;  
  }

  function vote_entry( sql_id, vote )
  {
    httpload( "index.php?pid=tutorials&cmd=viewent&id="+sql_id+"&rate="+vote, "content", "{language->loading}" );
  }

  function new_entry( is_doc, parent_sql_id, parent_text )
  {
    if( is_doc ){
      httpload( "index.php?pid=tutorials&cmd=newent&parent="+parent_sql_id, edit_entry_loaded, "{language->loading}" );      
      self_id = null;
    }else{
      httpload( "index.php?pid=tutorials&cmd=newcat&parent="+parent_sql_id, "content", "{language->loading}" );     
    }
    t();
    show_save_success=true;  
  }

  function delete_entry( is_doc, sql_id )
  {    
    var type = is_doc ? "doc" : "folder";
    httpload( "index.php?pid=tutorials&cmd=delete&id="+sql_id+"&type="+type, null );
  }

  function swap_entry( is_doc, sql_id1, sql_id2 )
  {
    var type = is_doc ? "doc" : "folder";
    httpload( "index.php?pid=tutorials&cmd=swap&id1="+sql_id1+"&id2="+sql_id2+"&type="+type, null );
  }

  function edit_entry_loaded( req )
  {                                   
    document.getElementById("content").innerHTML = req.responseText;
                               
    if(self_id){
      httpload( "index.php?pid=tutorials&cmd=xml_related&id="+self_id, related_loaded );
    }else{
      httpload( "index.php?pid=tutorials&cmd=xml_related", related_loaded );
    }
    t();
    httpload( "index.php?pid=filelibrary&cmd=xmltree", filelibrary_loaded );    
         
    // Load tutorials drop down menu
    setup_dommenu( "menu_dropdown", new Hash( "subMenuElementClass", "domMenu_subMenuParent" ) );
    domMenu_activate( "menu_dropdown" );    
  }

  function edit_entry_submit( )
  {
    httpload( "index.php?pid=tutorials&" + httpgetstring( "edit_form" ), tree_load, "{language->saving}" ); 
	t();
  }

  function choose_category( name, id ) // Select another tutorial category when editing an entry
  {
    dommenu_set_name( "menu_dropdown", name );       
    document.getElementById("parent").value = id;
  }

  function grab_file( name, id ) // Insert a file into currently edited entry
  {
    frames["wysiwyg_iframe_content"].inserthtml( "<img src=\"{script->url}images/attach_small.gif\" style=\"vertical-align: middle; border: 0px; margin-right: 5px\"><a hr"+"ef=\"{script->url}index.php?pid=file&fileid=" + id + "\">" + name + "</a> " );
  }
  
  ajax_allowed_functions( "display_entry","edit_entry","vote_entry","ticket_entry","search_tutorial","new_entry", "related_loaded", "delete_related" );

  if( !window.location.hash ) // Default history
    ajax_default_hash = "display_entry,false,0";

</script>